/*
 * NAME:
 *	socks - read/write network
 *
 * DESCRIPTION:
 *	See rwnet.c
 *
 * AUTHOR:
 *	Simon J. Gerraty <sjg@quick.com.au>
 */
/*
 *      @(#)Copyright (c) 1996 Simon J. Gerraty.
 *      
 *      This is free software.  It comes with NO WARRANTY.
 *      Permission to use, modify and distribute this source code 
 *      is granted subject to the following conditions.
 *      1/ that the above copyright notice and this notice 
 *      are preserved in all copies and that due credit be given 
 *      to the author.  
 *      2/ that any changes to this code are clearly commented 
 *      as such so that the author does not get blamed for bugs 
 *      other than his own.
 *      
 *      Please send copies of changes and bug-fixes to:
 *      sjg@quick.com.au
 */
#ifndef lint
static char RCSid[] = "$Id: socks.c,v 1.1 1997/05/29 14:33:25 sjg Exp $";
#endif

#ifdef SOCKS

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/param.h>

#include "socks.h"

#undef close
#undef read
#undef write


int
close(fd)
	int fd;
{
	static int myself = 0;
	int n;

	++myself;
	if (myself == 1)
		n = LIBPREFIX(close)(fd);
	else
		n = _close(fd);
	--myself;
	return n;
}

int
read(fd, buf, nbytes)
	int fd;
	unsigned char *buf;
	int nbytes;
{
	static int myself = 0;
	int n = 0;

	++myself;
	if (myself == 1)
		n = LIBPREFIX(read)(fd, buf, nbytes);
	else
		n = _read(fd, buf, nbytes);
	--myself;
	return n;
}

int
write(fd, buf, nbytes)
	int fd;
	unsigned char *buf;
	int nbytes;
{
	static int myself = 0;
	int n;

	++myself;
	if (myself == 1)
		n = LIBPREFIX(write)(fd, buf, nbytes);
	else
		n = _write(fd, buf, nbytes);
	--myself;
	return n;
}

#endif /* SOCKS */
